[BACK]Return to rc CVS log [TXT][DIR] Up to [local] / src / etc

Annotation of src/etc/rc, Revision 1.394

1.394   ! deraadt     1: #      $OpenBSD: rc,v 1.393 2011/09/16 10:11:20 robert Exp $
1.1       deraadt     2:
                      3: # System startup script run by init on autoboot
                      4: # or after single-user.
                      5: # Output and error are redirected to console by init,
                      6: # and the console is the controlling terminal.
                      7:
1.131     millert     8: # Subroutines (have to come first).
                      9:
                     10: # Strip comments (and leading/trailing whitespace if IFS is set)
                     11: # from a file and spew to stdout
                     12: stripcom() {
                     13:        local _file="$1"
                     14:        local _line
                     15:
                     16:        {
                     17:                while read _line ; do
                     18:                        _line=${_line%%#*}              # strip comments
                     19:                        test -z "$_line" && continue
                     20:                        echo $_line
                     21:                done
                     22:        } < $_file
                     23: }
                     24:
1.265     millert    25: # Update resource limits when sysctl changes
                     26: # Usage: update_limit -X loginconf_name
                     27: update_limit() {
                     28:        local _fl="$1"  # ulimit flag
                     29:        local _lc="$2"  # login.conf name
                     30:        local _new _suf
                     31:
                     32:        for _suf in "" -cur -max; do
                     33:                _new=`getcap -f /etc/login.conf -s ${_lc}${_suf} daemon 2>/dev/null`
                     34:                if [ X"$_new" != X"" ]; then
                     35:                        if [ X"$_new" = X"infinity" ]; then
                     36:                                _new=unlimited
                     37:                        fi
                     38:                        case "$_suf" in
                     39:                        -cur)
                     40:                                ulimit -S $_fl $_new
                     41:                                ;;
                     42:                        -max)
                     43:                                ulimit -H $_fl $_new
                     44:                                ;;
                     45:                        *)
                     46:                                ulimit $_fl $_new
                     47:                                return
                     48:                                ;;
                     49:                        esac
                     50:                fi
                     51:        done
                     52: }
                     53:
                     54: sysctl_conf() {
1.267     millert    55:        test -s /etc/sysctl.conf || return
                     56:
1.265     millert    57:        # delete comments and blank lines
                     58:        set -- `stripcom /etc/sysctl.conf`
                     59:        while [ $# -ge 1 ] ; do
                     60:                sysctl $1
                     61:                # update limits if needed
                     62:                case $1 in
                     63:                kern.maxproc=*)
                     64:                        update_limit -p maxproc
                     65:                        ;;
                     66:                kern.maxfiles=*)
                     67:                        update_limit -n openfiles
                     68:                        ;;
                     69:                esac
                     70:                shift
                     71:        done
                     72: }
                     73:
                     74: mixerctl_conf()
                     75: {
1.267     millert    76:        test -s /etc/mixerctl.conf || return
                     77:
1.265     millert    78:        # delete comments and blank lines
                     79:        set -- `stripcom /etc/mixerctl.conf`
                     80:        while [ $# -ge 1 ] ; do
                     81:                mixerctl -q $1 > /dev/null 2>&1
                     82:                shift
                     83:        done
                     84: }
                     85:
1.267     millert    86: wsconsctl_conf()
                     87: {
                     88:        local save_IFS="$IFS"
                     89:
                     90:        test -x /sbin/wsconsctl -a -s /etc/wsconsctl.conf || return
                     91:        # delete comments and blank lines
                     92:        IFS="
                     93: "
                     94:        set -- `stripcom /etc/wsconsctl.conf`
                     95:        IFS="$save_IFS"
                     96:        while [ $# -ge 1 ] ; do
1.356     deraadt    97:                eval wsconsctl $1
1.267     millert    98:                shift
                     99:        done
                    100: }
                    101:
1.312     djm       102: random_seed()
                    103: {
1.389     deraadt   104:        if [ -f /var/db/host.random ]; then
1.347     deraadt   105:                dd if=/var/db/host.random of=/dev/arandom bs=65536 count=1 \
1.312     djm       106:                    > /dev/null 2>&1
1.389     deraadt   107:                chmod 600 /var/db/host.random >/dev/null 2>&1
1.328     deraadt   108:
1.312     djm       109:                # reset seed file, so that if a shutdown-less reboot occurs,
                    110:                # the next seed is not a repeat
1.347     deraadt   111:                dd if=/dev/arandom of=/var/db/host.random bs=65536 count=1 \
1.312     djm       112:                    > /dev/null 2>&1
                    113:        fi
                    114: }
                    115:
1.318     djm       116: fill_baddynamic()
                    117: {
1.390     halex     118:        local _service=$1
1.318     djm       119:        local _sysctl="net.inet.${_service}.baddynamic"
1.390     halex     120:        stripcom /etc/services |
                    121:        {
                    122:                # Variables are local
                    123:                while IFS="     /" read _name _port _srv _junk; do
1.391     halex     124:                        [ "x${_srv}" = "x${_service}" ] || continue
1.390     halex     125:                        _ban="${_ban:+${_ban},}+${_port}"
                    126:                        # Flush before argv gets too long
                    127:                        if [ ${#_ban} -gt 1024 ]; then
                    128:                                sysctl -q ${_sysctl}=${_ban}
                    129:                                _ban=""
                    130:                        fi
                    131:                done
                    132:                [ "${_ban}" ] && sysctl -q ${_sysctl}=${_ban}
                    133:        }
1.318     djm       134: }
                    135:
1.353     robert    136: start_daemon()
                    137: {
1.354     robert    138:        local _n
1.353     robert    139:        for _n; do
                    140:                eval _do=\${${_n}_flags}
                    141:                if [ X"${_do}" != X"NO" ]; then
                    142:                        /etc/rc.d/${_n} start
                    143:                fi
                    144:        done
                    145: }
                    146:
1.373     deraadt   147: make_keys()
                    148: {
                    149:        if [ X"${named_flags}" != X"NO" ]; then
                    150:                if ! cmp -s /etc/rndc.key /var/named/etc/rndc.key ; then
                    151:                        echo -n "rndc-confgen: generating shared secret... "
                    152:                        if rndc-confgen -a -t /var/named >/dev/null 2>&1; then
                    153:                                chmod 0640 /var/named/etc/rndc.key \
                    154:                                    >/dev/null 2>&1
                    155:                                echo done.
                    156:                        else
                    157:                                echo failed.
                    158:                        fi
                    159:                fi
                    160:        fi
                    161:
                    162:        if [ ! -f /etc/isakmpd/private/local.key ]; then
                    163:                echo -n "openssl: generating isakmpd/iked RSA key... "
                    164:                if openssl genrsa -out /etc/isakmpd/private/local.key 2048 \
                    165:                    >/dev/null 2>&1; then
                    166:                        chmod 600 /etc/isakmpd/private/local.key
                    167:                        openssl rsa -out /etc/isakmpd/local.pub -in \
                    168:                            /etc/isakmpd/private/local.key -pubout \
                    169:                            >/dev/null 2>&1
                    170:                        echo done.
                    171:                else
                    172:                        echo failed.
                    173:                fi
                    174:        fi
                    175:
                    176:        if [ ! -f /etc/iked/private/local.key ]; then
                    177:                # Just copy the generated isakmpd key
                    178:                cp /etc/isakmpd/private/local.key /etc/iked/private/local.key
                    179:                chmod 600 /etc/iked/private/local.key
                    180:                cp /etc/isakmpd/local.pub /etc/iked/local.pub
                    181:        fi
                    182:
                    183:        ssh-keygen -A
                    184: }
                    185:
                    186: # create Unix sockets directories for X if needed and make sure they have
                    187: # correct permissions
                    188: setup_X_sockets()
                    189: {
                    190:        if [ -d /usr/X11R6/lib ]; then
                    191:                for d in /tmp/.X11-unix /tmp/.ICE-unix ; do
                    192:                        if [ -d $d ]; then
                    193:                                if [ `ls -ld $d | cut -d' ' -f4` \
                    194:                                    != root ]; then
                    195:                                        chown root $d
                    196:                                fi
                    197:                                if [ `ls -ld $d | cut -d' ' -f1` \
                    198:                                    != drwxrwxrwt ]; then
                    199:                                        chmod 1777 $d
                    200:                                fi
                    201:                        elif [ -e $d ]; then
                    202:                                echo "Error: $d exists and isn't a directory."
                    203:                        else
                    204:                                mkdir -m 1777 $d
                    205:                        fi
                    206:                done
                    207:        fi
                    208: }
                    209:
1.131     millert   210: # End subroutines
                    211:
1.1       deraadt   212: stty status '^T'
                    213:
                    214: # Set shell to ignore SIGINT (2), but not children;
                    215: # shell catches SIGQUIT (3) and returns to single user after fsck.
                    216: trap : 2
                    217: trap : 3       # shouldn't be needed
                    218:
                    219: HOME=/; export HOME
1.349     robert    220: INRC=1; export INRC
1.1       deraadt   221: PATH=/sbin:/bin:/usr/sbin:/usr/bin
                    222: export PATH
1.108     deraadt   223:
1.343     robert    224: # pick up option configuration
                    225: . /etc/rc.conf
                    226:
1.266     millert   227: if [ X"$1" = X"shutdown" ]; then
1.347     deraadt   228:        dd if=/dev/arandom of=/var/db/host.random bs=65536 count=1 >/dev/null 2>&1
1.108     deraadt   229:        chmod 600 /var/db/host.random >/dev/null 2>&1
1.352     ajacouto  230:        local _c=$?
1.380     ajacouto  231:        if [ ${_c} -eq 0 -a -n "${pkg_scripts}" ]; then
1.352     ajacouto  232:                echo -n 'stopping package daemons:'
1.380     ajacouto  233:                while [ -n "${pkg_scripts}" ]; do
                    234:                        _r=${pkg_scripts##* }
                    235:                        pkg_scripts=${pkg_scripts%%*( )${_r}}
1.352     ajacouto  236:                        [ -x /etc/rc.d/${_r} ] && /etc/rc.d/${_r} stop
                    237:                done
                    238:                echo '.'
                    239:        fi
                    240:        if [ ${_c} -eq 0 -a -f /etc/rc.shutdown ]; then
1.108     deraadt   241:                echo /etc/rc.shutdown in progress...
                    242:                . /etc/rc.shutdown
                    243:                echo /etc/rc.shutdown complete.
1.240     mcbride   244:
                    245:                # bring carp interfaces down gracefully
1.331     sthen     246:                ifconfig | while read a b; do
                    247:                        case $a in
                    248:                        carp+([0-9]):) ifconfig ${a%:} down ;;
1.329     sthen     249:                        esac
1.240     mcbride   250:                done
1.246     mcbride   251:
1.266     millert   252:                if [ X"${powerdown}" = X"YES" ]; then
1.246     mcbride   253:                        exit 2
                    254:                fi
                    255:
1.108     deraadt   256:        else
                    257:                echo single user: not running /etc/rc.shutdown
                    258:        fi
                    259:        exit 0
1.1       deraadt   260: fi
1.98      jakob     261:
                    262: # Configure raid devices.
                    263: for dev in 0 1 2 3; do
                    264:        if [ -f /etc/raid$dev.conf ]; then
                    265:                raidctl -c /etc/raid$dev.conf raid$dev
                    266:        fi
                    267: done
1.190     tdeval    268:
                    269: # Check parity on raid devices.
1.191     deraadt   270: raidctl -P all
1.1       deraadt   271:
1.172     miod      272: swapctl -A -t blk
1.170     deraadt   273:
1.17      deraadt   274: if [ -e /fastboot ]; then
1.1       deraadt   275:        echo "Fast boot: skipping disk checks."
1.266     millert   276: elif [ X"$1" = X"autoboot" ]; then
1.1       deraadt   277:        echo "Automatic boot in progress: starting file system checks."
1.31      millert   278:        fsck -p
1.1       deraadt   279:        case $? in
                    280:        0)
                    281:                ;;
                    282:        2)
                    283:                exit 1
                    284:                ;;
                    285:        4)
                    286:                echo "Rebooting..."
                    287:                reboot
                    288:                echo "Reboot failed; help!"
                    289:                exit 1
                    290:                ;;
                    291:        8)
                    292:                echo "Automatic file system check failed; help!"
                    293:                exit 1
                    294:                ;;
                    295:        12)
                    296:                echo "Boot interrupted."
                    297:                exit 1
                    298:                ;;
                    299:        130)
                    300:                # interrupt before catcher installed
                    301:                exit 1
                    302:                ;;
                    303:        *)
                    304:                echo "Unknown error; help!"
                    305:                exit 1
                    306:                ;;
                    307:        esac
                    308: fi
                    309:
                    310: trap "echo 'Boot interrupted.'; exit 1" 3
                    311:
                    312: umount -a >/dev/null 2>&1
1.303     grunk     313: mount -a -t nonfs,vnd
1.57      niklas    314: mount -uw /            # root on nfs requires this, others aren't hurt
1.1       deraadt   315: rm -f /fastboot                # XXX (root now writeable)
1.177     deraadt   316:
1.255     henning   317: # set flags on ttys.  (do early, in case they use tty for SLIP in netstart)
1.1       deraadt   318: echo 'setting tty flags'
                    319: ttyflags -a
1.77      angelos   320:
1.252     mcbride   321: if [ -f /sbin/kbd -a -f /etc/kbdtype ]; then
                    322:        kbd `cat /etc/kbdtype`
                    323: fi
                    324:
1.279     deraadt   325: wsconsctl_conf
                    326:
1.266     millert   327: if [ X"${pf}" != X"NO" ]; then
1.211     mcbride   328:        RULES="block all"
1.228     henning   329:        RULES="$RULES\npass on lo0"
1.195     dhartmei  330:        RULES="$RULES\npass in proto tcp from any to any port 22 keep state"
1.208     camield   331:        RULES="$RULES\npass out proto { tcp, udp } from any to any port 53 keep state"
1.215     camield   332:        RULES="$RULES\npass out inet proto icmp all icmp-type echoreq keep state"
1.257     grange    333:        if ifconfig lo0 inet6 >/dev/null 2>&1; then
1.258     itojun    334:                RULES="$RULES\npass out inet6 proto icmp6 all icmp6-type neighbrsol"
                    335:                RULES="$RULES\npass in inet6 proto icmp6 all icmp6-type neighbradv"
1.257     grange    336:                RULES="$RULES\npass out inet6 proto icmp6 all icmp6-type routersol"
                    337:                RULES="$RULES\npass in inet6 proto icmp6 all icmp6-type routeradv"
                    338:        fi
1.322     mcbride   339:        RULES="$RULES\npass proto carp keep state (no-sync)"
1.193     deraadt   340:        case `sysctl vfs.mounts.nfs 2>/dev/null` in
1.184     deraadt   341:        *[1-9]*)
                    342:                # don't kill NFS
1.324     henning   343:                RULES="set reassemble yes no-df\n$RULES"
1.306     deraadt   344:                RULES="$RULES\npass in proto { tcp, udp } from any port { 111, 2049 } to any"
                    345:                RULES="$RULES\npass out proto { tcp, udp } from any to any port { 111, 2049 }"
1.184     deraadt   346:                ;;
                    347:        esac
1.269     dhartmei  348:        echo $RULES | pfctl -f -
                    349:        pfctl -e
1.176     kjell     350: fi
1.318     djm       351:
                    352: # Fill net.inet.(tcp|udp).baddynamic lists from /etc/services
                    353: fill_baddynamic udp
                    354: fill_baddynamic tcp
1.176     kjell     355:
1.267     millert   356: sysctl_conf
1.260     jsg       357:
1.1       deraadt   358: # set hostname, turn on network
                    359: echo 'starting network'
1.289     henning   360: ifconfig -g carp carpdemote 128
1.264     deraadt   361: if [ -f /etc/resolv.conf.save ]; then
1.334     deraadt   362:        mv -f /etc/resolv.conf.save /etc/resolv.conf
1.264     deraadt   363:        touch /etc/resolv.conf
                    364: fi
1.1       deraadt   365: . /etc/netstart
1.348     deraadt   366: echo rekey > /dev/arandom      # any write triggers an RC4 rekey
1.176     kjell     367:
1.266     millert   368: if [ X"${pf}" != X"NO" ]; then
1.176     kjell     369:        if [ -f ${pf_rules} ]; then
1.198     dhartmei  370:                pfctl -f ${pf_rules}
1.309     mpf       371:        fi
                    372:        # bring up pfsync after the working ruleset has been loaded
1.367     deraadt   373:        if [ -f /etc/hostname.pfsync0 ]; then
                    374:                . /etc/netstart pfsync0
                    375:        fi
1.176     kjell     376: fi
1.1       deraadt   377:
1.278     otto      378: mount -s /usr >/dev/null 2>&1
                    379: mount -s /var >/dev/null 2>&1
1.180     deraadt   380:
1.389     deraadt   381: random_seed
1.29      deraadt   382:
1.55      deraadt   383: # clean up left-over files
1.376     deraadt   384: rm -f /etc/nologin /var/spool/lock/LCK.* /var/spool/uucp/STST/*
1.247     henning   385: (cd /var/run && { rm -rf -- *; install -c -m 664 -g utmp /dev/null utmp; })
1.196     beck      386: (cd /var/authpf && rm -rf -- *)
1.96      alex      387:
                    388: # save a copy of the boot messages
                    389: dmesg >/var/run/dmesg.boot
1.55      deraadt   390:
1.373     deraadt   391: make_keys
                    392:
1.379     deraadt   393: echo -n 'starting early daemons:'
1.387     deraadt   394: start_daemon syslogd ldattach pflogd named nsd ntpd isakmpd iked sasyncd
1.353     robert    395: echo '.'
1.280     hshoexer  396:
                    397: if [ X"${ipsec}" != X"NO" ]; then
                    398:        if [ -f ${ipsec_rules} ]; then
                    399:                ipsecctl -f ${ipsec_rules}
                    400:        fi
1.40      provos    401: fi
1.1       deraadt   402:
1.379     deraadt   403: echo -n 'starting RPC daemons:'
1.355     robert    404: start_daemon portmap
1.376     deraadt   405: if [ X"`domainname`" != X"" ]; then
1.385     deraadt   406:        start_daemon ypserv ypbind yppasswdd
1.376     deraadt   407: fi
1.385     deraadt   408: start_daemon ypldap mountd nfsd lockd statd amd
1.1       deraadt   409: echo '.'
1.58      deraadt   410:
1.278     otto      411: mount -a
1.172     miod      412: swapctl -A -t noblk
1.1       deraadt   413:
                    414: # /var/crash should be a directory or a symbolic link
                    415: # to the crash directory if core dumps are to be saved.
                    416: if [ -d /var/crash ]; then
1.188     tholo     417:        savecore ${savecore_flags} /var/crash
1.90      art       418: fi
                    419:
1.266     millert   420: if [ X"${check_quotas}" = X"YES" ]; then
1.41      downsj    421:        echo -n 'checking quotas:'
                    422:        quotacheck -a
                    423:        echo ' done.'
                    424:        quotaon -a
                    425: fi
1.1       deraadt   426:
1.376     deraadt   427: kvm_mkdb                       # build kvm(3) databases
1.1       deraadt   428: dev_mkdb
1.101     deraadt   429: chmod 666 /dev/tty[pqrstuvwxyzPQRST]*
1.226     millert   430: chown root:wheel /dev/tty[pqrstuvwxyzPQRST]*
1.1       deraadt   431:
                    432: # check the password temp/lock file
1.17      deraadt   433: if [ -f /etc/ptmp ]; then
1.1       deraadt   434:        logger -s -p auth.err \
1.376     deraadt   435:            'password file may be incorrect -- /etc/ptmp exists'
1.32      deraadt   436: fi
                    437:
1.49      millert   438: echo clearing /tmp
                    439:
                    440: # prune quickly with one rm, then use find to clean up /tmp/[lq]*
                    441: # (not needed with mfs /tmp, but doesn't hurt there...)
1.339     sthen     442: (cd /tmp && rm -rf [a-km-pr-zA-Z]*)
                    443: (cd /tmp &&
1.49      millert   444:     find . ! -name . ! -name lost+found ! -name quota.user \
1.103     millert   445:        ! -name quota.group -execdir rm -rf -- {} \; -type d -prune)
1.373     deraadt   446:
                    447: setup_X_sockets
1.203     hugh      448:
1.72      deraadt   449: [ -f /etc/rc.securelevel ] && . /etc/rc.securelevel
1.266     millert   450: if [ X"${securelevel}" != X"" ]; then
1.33      millert   451:        echo -n 'setting kernel security level: '
1.234     jmc       452:        sysctl kern.securelevel=${securelevel}
1.1       deraadt   453: fi
                    454:
1.34      deraadt   455: # patch /etc/motd
                    456: if [ ! -f /etc/motd ]; then
                    457:        install -c -o root -g wheel -m 664 /dev/null /etc/motd
                    458: fi
1.364     guenther  459: if T=`mktemp /tmp/_motd.XXXXXXXXXX`; then
1.102     millert   460:        sysctl -n kern.version | sed 1q > $T
                    461:        echo "" >> $T
                    462:        sed '1,/^$/d' < /etc/motd >> $T
                    463:        cmp -s $T /etc/motd || cp $T /etc/motd
                    464:        rm -f $T
                    465: fi
1.34      deraadt   466:
1.298     ajacouto  467: if [ X"${accounting}" = X"YES" ]; then
                    468:        if [ ! -f /var/account/acct ]; then
                    469:                touch /var/account/acct
                    470:        fi
1.1       deraadt   471:        echo 'turning on accounting';   accton /var/account/acct
                    472: fi
                    473:
1.363     deraadt   474: if [ -f /sbin/ldconfig ]; then
1.115     deraadt   475:        echo 'creating runtime link editor directory cache.'
                    476:        if [ -d /usr/local/lib ]; then
1.183     todd      477:                shlib_dirs="/usr/local/lib $shlib_dirs"
1.115     deraadt   478:        fi
                    479:        if [ -d /usr/X11R6/lib ]; then
1.183     todd      480:                shlib_dirs="/usr/X11R6/lib $shlib_dirs"
1.115     deraadt   481:        fi
                    482:        ldconfig $shlib_dirs
1.231     millert   483: fi
                    484:
1.376     deraadt   485: echo 'preserving editor files.';       /usr/libexec/vi.recover
1.244     markus    486:
1.353     robert    487: echo -n 'starting network daemons:'
1.383     deraadt   488: start_daemon sshd snmpd ldpd ripd ospfd ospf6d bgpd ifstated
                    489: start_daemon relayd dhcpd dhcrelay mrouted dvmrpd
1.127     itojun    490:
                    491: if ifconfig lo0 inet6 >/dev/null 2>&1; then
                    492:        fw=`sysctl -n net.inet6.ip6.forwarding`
1.266     millert   493:        if [ X"${fw}" = X"0" ]; then
1.353     robert    494:                start_daemon rtsold
1.127     itojun    495:        else
1.376     deraadt   496:                start_daemon route6d rtadvd
1.127     itojun    497:        fi
1.281     reyk      498: fi
                    499:
1.371     deraadt   500: start_daemon hostapd rwhod lpd ldapd sendmail smtpd httpd ftpd
1.377     robert    501: start_daemon ftpproxy identd inetd rarpd bootparamd rbootd mopd
1.393     robert    502: start_daemon popa3d spamd spamlogd kdc kadmind kpasswdd aucat
1.377     robert    503: echo '.'
1.365     robert    504:
1.379     deraadt   505: if [ X"${spamd_flags}" != X"NO" ]; then
1.319     deraadt   506:        /usr/libexec/spamd-setup -D
1.17      deraadt   507: fi
1.335     deraadt   508:
                    509: # If rc.firstime exists, run it just once, and make sure it is deleted
                    510: if [ -f /etc/rc.firsttime ]; then
                    511:        mv /etc/rc.firsttime /etc/rc.firsttime.run
1.384     halex     512:        . /etc/rc.firsttime.run 2>&1 | tee /dev/tty |
1.392     halex     513:                mail -Es "`hostname` rc.firsttime output" root >/dev/null
1.335     deraadt   514: fi
                    515: rm -f /etc/rc.firsttime.run
1.352     ajacouto  516:
                    517: # Run rc.d(8) scripts from packages
1.380     ajacouto  518: if [ -n "${pkg_scripts}" ]; then
1.352     ajacouto  519:        echo -n 'starting package daemons:'
1.380     ajacouto  520:        for _r in $pkg_scripts; do
1.368     robert    521:                [ -x /etc/rc.d/${_r} ] && start_daemon ${_r}
1.352     ajacouto  522:        done
                    523:        echo '.'
                    524: fi
1.17      deraadt   525:
1.72      deraadt   526: [ -f /etc/rc.local ] && . /etc/rc.local
1.73      millert   527:
1.379     deraadt   528: ifconfig -g carp -carpdemote 128       # disable carp interlock
1.286     mcbride   529:
1.379     deraadt   530: mixerctl_conf
                    531: echo -n 'starting local daemons:'
1.386     deraadt   532: start_daemon apmd sensorsd hotplugd watchdogd cron wsmoused xdm
1.73      millert   533: echo '.'
1.1       deraadt   534:
                    535: date
                    536: exit 0